debSystem Class Reference
Inheritance diagram for debSystem:
[legend]
Collaboration diagram for debSystem:
[legend]

## Public Member Functions

bool | Lock (OpProgress *Progress) override
bool | UnLock (bool NoErrors=false) override
pkgPackageManager * | CreatePM (pkgDepCache *Cache) const override
bool | Initialize (Configuration &Cnf) override
bool | ArchiveSupported (const char *Type) override
signed | Score (Configuration const &Cnf) override
bool | AddStatusFiles (std::vector< pkgIndexFile * > &List) override
bool | FindIndex (pkgCache::PkgFileIterator File, pkgIndexFile *&Found) const override
bool | MultiArchSupported () const override
std::vector< std::string > | ArchitecturesSupported () const override
bool | LockInner (OpProgress *const Progress, int timeoutSec) override
bool | UnLockInner (bool NoErrors=false) override
bool | IsLocked () override
| checks if the system is currently locked
Public Member Functions inherited from pkgSystem
APT_HIDDEN void | SetVersionMapping (map_id_t const in, map_id_t const out)
APT_HIDDEN map_id_t | GetVersionMapping (map_id_t const in) const
| pkgSystem (char const *const Label, pkgVersioningSystem *const VS)

## Static Public Member Functions

static APT_HIDDEN std::string | GetDpkgExecutable ()
static APT_HIDDEN std::vector< std::string > | GetDpkgBaseCommand ()
static APT_HIDDEN void | DpkgChrootDirectory ()
static APT_HIDDEN std::string | StripDpkgChrootDirectory (std::string const &File)
static APT_HIDDEN pid_t | ExecDpkg (std::vector< std::string > const &sArgs, int *const inputFd, int *const outputFd, bool const DiscardOutput)
static bool | AssertFeature (std::string const &Feature)
Static Public Member Functions inherited from pkgSystem
static pkgSystem * | GetSystem (const char *Label)

## Additional Inherited Members

Public Attributes inherited from pkgSystem
const char *const | Label
pkgVersioningSystem *const | VS
Static Public Attributes inherited from pkgSystem
static pkgSystem ** | GlobalList = SysList
static unsigned long | GlobalListLen = 0

## Member Function Documentation

## AddStatusFiles()

bool AddStatusFiles | ( | std::vector< pkgIndexFile * > & | List | ) |

override virtual

Implements pkgSystem.

## ArchitecturesSupported()

std::vector< std::string > ArchitecturesSupported | ( |  | ) | const

override virtual

architectures supported by this system

A MultiArch capable system might be configured to use this capability.

Returns
  a list of all architectures (native + foreign) configured for on this system (aka: which can be installed without force)

Implements pkgSystem.

## ArchiveSupported()

APT_PURE bool ArchiveSupported | ( | const char * | Type | ) |

override virtual

Implements pkgSystem.

## CreatePM()

pkgPackageManager * CreatePM | ( | pkgDepCache * | Cache | ) | const

override virtual

Implements pkgSystem.

## FindIndex()

bool FindIndex | ( | pkgCache::PkgFileIterator | File,
|  | pkgIndexFile *& | Found ) const

override virtual

Implements pkgSystem.

## Initialize()

bool Initialize | ( | Configuration & | Cnf | ) |

override virtual

Reimplemented from pkgSystem.

## IsLocked()

bool IsLocked | ( |  | ) |

override virtual

checks if the system is currently locked

Implements pkgSystem.

## Lock()

bool Lock | ( | OpProgress * | Progress | ) |

override virtual

Implements pkgSystem.

## LockInner()

bool LockInner | ( | OpProgress *const | Progress,
|  | int | timeoutSec )

override virtual

Implements pkgSystem.

## MultiArchSupported()

bool MultiArchSupported | ( |  | ) | const

override virtual

Todo
  these methods should be virtual

does this system has support for MultiArch?

Systems supporting only single arch (not systems which are single arch) are considered legacy systems and support for it will likely degrade over time.

The default implementation returns always true.

Returns
  true if the system supports MultiArch, false if not.

Implements pkgSystem.

## Score()

signed Score | ( | Configuration const & | Cnf | ) |

override virtual

Reimplemented from pkgSystem.

## UnLock()

bool UnLock | ( | bool | NoErrors = false | ) |

override virtual

Implements pkgSystem.

## UnLockInner()

bool UnLockInner | ( | bool | NoErrors = false | ) |

override virtual

Implements pkgSystem.

The documentation for this class was generated from the following files:

- apt-pkg/deb/debsystem.h
- apt-pkg/deb/debsystem.cc